VERSION 5.00
Begin VB.Form frmNetTime 
   Caption         =   "Form2"
   ClientHeight    =   1695
   ClientLeft      =   6825
   ClientTop       =   5475
   ClientWidth     =   3375
   BeginProperty Font 
      Name            =   "Arial"
      Size            =   9.75
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form2"
   ScaleHeight     =   1695
   ScaleWidth      =   3375
   Begin VB.ComboBox cboTimeServer 
      Height          =   360
      Left            =   120
      Style           =   2  'Dropdown-Liste
      TabIndex        =   3
      Top             =   120
      Width           =   3135
   End
   Begin VB.CommandButton cmdQuit 
      Caption         =   "Quit"
      Height          =   495
      Left            =   2040
      TabIndex        =   2
      Top             =   1080
      Width           =   1215
   End
   Begin VB.CommandButton cmdGetTime 
      Caption         =   "Get Time"
      Height          =   495
      Left            =   120
      TabIndex        =   1
      Top             =   1080
      Width           =   1215
   End
   Begin VB.TextBox txtDateTime 
      Height          =   360
      Left            =   120
      TabIndex        =   0
      Text            =   "Text1"
      Top             =   600
      Width           =   3135
   End
End
Attribute VB_Name = "frmNetTime"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'   Fr dieses Beispiel ist eine Klasse ntig, die hier zu finden ist:
'   http://www.vbip.com/winsock-api/csocket-class/csocket-class-01.asp
'   Ich halte es fr Zeitverschwendung, die Klasse in meinen Code zu
'   kopieren und unkenntlich zu machen, da ich mir fremde Leistung
'   aneignen wrde.
'   Die Klasse von vbip.com ist ein sehr guter Ersatz fr das
'   Winsock-Control, sie ist nahezu vollstndig und bis auf wenige
'   Ausnahmen gleich aufgebaut.
'   Ich habe die Klasse von vbip.com mit in das Archiv gepackt, damit
'   nicht erst gro runtergeladen werden mu.

'   (Mehr oder weniger) Aktuelle Listen verschiedener Zeitserver sind
'   hier zu finden:
'   -   http://www.robertkehl.de/?page=/ntp.php
'   -   http://hullen.de/helmut/filebox/DCF77/ntpsrvr.txt
'   Einige der dort aufgefhrten Server liefern keine Antwort.

Option Explicit

Private blnGetTime As Boolean

Private Function FormatDateTime() As String
    '   Aktuelle Systemzeit formatieren
    FormatDateTime = Format$(Now, "ddd\,\ dd\.\ mmm\.\ yyyy\ hh\:nn\:ss")
End Function

Private Sub cmdGetTime_Click()
    Dim objNetTime As clsNetTime
    
    '   Die Zeit wird gerade geholt
    blnGetTime = True
    Me.cmdGetTime.Enabled = False
    Me.cmdQuit.Enabled = False
    
    '   Klasse initialisieren
    Set objNetTime = New clsNetTime
    
    '   Zeit holen
    With objNetTime
        .SetTime = False
        Call .Init(Me.cboTimeServer.Text)
        Call .Run
        Call .Done
    End With
    
    '   Das war es schon
    Set objNetTime = Nothing
    
    '   Zeit eintragen
    Me.txtDateTime = FormatDateTime

    '   Die Zeit wurde gerade geholt
    blnGetTime = False
    Me.cmdGetTime.Enabled = True
    Me.cmdQuit.Enabled = True
End Sub

Private Sub cmdQuit_Click()
    '   Beenden
    Unload Me
End Sub

Private Sub Form_Load()
    '   Liste mit Zeitservern
    With Me.cboTimeServer
        .AddItem "ptbtime1.ptb.de"
        .AddItem "ptbtime2.ptb.de"
        .AddItem "ntp0.fau.de"
        .AddItem "ntp1.fau.de"
        .AddItem "ntp2.fau.de"
        .AddItem "ntp3.fau.de"
        .AddItem "ntps1-0.cs.tu-berlin.de"
        .AddItem "ntps1-1.cs.tu-berlin.de"
        .AddItem "ntps1-0.uni-erlangen.de"
        .AddItem "ntp1.sda.t-online.de"
        .AddItem "ntp.metas.ch"
        .ListIndex = 0
    End With
    
    '   Zeit eintragen
    With Me.txtDateTime
        .Locked = True
        .Text = FormatDateTime
    End With
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    '   Solange die Zeit noch geholt wird,
    '   darf die Anwendung nicht beendet werden!
    Cancel = CInt(blnGetTime)
End Sub
